﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.Objects;

namespace EF_Crud_Basico
{
    public partial class Form1 : Form
    {
        CadastroEntities contextoDados;
        List<ESTADO> estadoLista;
        int indiceAtualEstado = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            contextoDados = new CadastroEntities();
            estadoLista = new List<ESTADO>();

            ObjectQuery<ESTADO> estadoConsulta = contextoDados.Estados.Where("it.sigla <> 'nada'");

            estadoLista = estadoConsulta.ToList();
            gdvEstados.DataSource = estadoConsulta.ToList();

            MessageBox.Show(estadoConsulta.ToTraceString());
            PreencheCampos();
        }

        private void PreencheCampos()
        {
            ESTADO estadoAtual = estadoLista[indiceAtualEstado];
            txtID.Text = estadoAtual.id.ToString();
            txtSigla.Text = estadoAtual.sigla;
            txtEstado.Text = estadoAtual.nome;
            //articleCountLabel.Text = currentAuthor.Article.Count.ToString();
            //authorIDLabel.Text = currentAuthor.AuthorID.ToString();
        }

        private void btnPrimeiro_Click(object sender, EventArgs e)
        {
            indiceAtualEstado = 0;
            PreencheCampos();
        }

        private void btnAnterior_Click(object sender, EventArgs e)
        {
            if (indiceAtualEstado == 0)
            {
                MessageBox.Show("Não há mais estados");
            }
            else
            {
                indiceAtualEstado -= 1;
                PreencheCampos();
            }
        }

        private void btnProximo_Click(object sender, EventArgs e)
        {

            if (indiceAtualEstado == estadoLista.Count - 1)
            {
                MessageBox.Show("Fim de estados");
                PreencheCampos();
            }
            else
            {
                indiceAtualEstado += 1;
                PreencheCampos();
            }            
        }

        private void btnUltimo_Click(object sender, EventArgs e)
        {
            indiceAtualEstado = estadoLista.Count - 1;
            PreencheCampos();
        }

        private void btnAtualizar_Click(object sender, EventArgs e)
        {
            ESTADO estadoAtual = estadoLista[indiceAtualEstado];
            estadoAtual.sigla = txtSigla.Text;
            estadoAtual.nome = txtEstado.Text;
        }

        private void btnNovo_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Confirma inclusão do registro ?", "Estados", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) == DialogResult.OK)
            {
                limparCampos();
                ESTADO novoEstado = new ESTADO();
                novoEstado.sigla = txtSigla.Text;
                novoEstado.nome = txtEstado.Text;
                novoEstado.id = -1;      //para deixar claro que um novo estado
                estadoLista.Add(novoEstado);
                contextoDados.AddToEstados(novoEstado);
                indiceAtualEstado = estadoLista.Count - 1;  //Define o indice para último do novo item
                PreencheCampos();
            }
        }

        private void btnSalvar_Click(object sender, EventArgs e)
        {
            int linhasAfetadas = contextoDados.SaveChanges(true);
            MessageBox.Show(linhasAfetadas.ToString() + " atualizações persistidas no banco de dados.");
            PreencheCampos();
        }

        private void limparCampos()
        {
            txtSigla.Text = string.Empty;
            txtEstado.Text = string.Empty;
            txtID.Text = "NOVO";
        }
    }



}
